ormicida_benchmarks
===================

Benchmarks tracking the performance of Ormicida serialization/validation.

dynamic.dart
  A benchmark to compare various serializations, using ormicida_codec
  default inspector (SimpleInspector) and builder (SimpleBuilder).

serialization.dart
  A benchmark to compare various serialization libraries, without validation:
    - Pixm (see package ormicida_pixm)
    - Json (see package ormicida_json)
    - Bson (see package ormicida_bson)
    - Bson2 (see package bson)
    - Convert (Dart's native Json/UTF-8 codecs)

validation.dart
  A benchmark to compare validation with various kinds of Schemas

# Results

obtained on (unchecked):
    2014-03-20
    Dart VM version: 1.3.0-dev.4.1 (Sun Mar 16 12:31:12 2014) on "windows_ia32"
    Windows 7 Professional (64-bits) (SP1)
    Intel Core2 Duo 3.17GHz
    4GB RAM


# codec_dynamic.dart

  Codec           Encode       %      Decode       %       Total       %        Size       %
##  little  ################################################################################
  pixm              7.83    1.00       14.01    1.03       21.41    1.00          30    1.00
  json              8.16    1.04       17.71    1.30       27.78    1.30          41    1.37
  bson              7.86    1.00       13.63    1.00       22.36    1.04          34    1.13
  bson2            14.84    1.90       20.67    1.52       37.19    1.74          34    1.13
  convert          23.96    3.06       17.88    1.31       43.90    2.05          41    1.37
##  medium  ################################################################################
  pixm            143.07    1.07      201.82    1.00      353.61    1.00         565    1.00
  json            166.44    1.24      373.83    1.85      570.78    1.61         850    1.50
  bson            134.26    1.00      318.52    1.58      461.89    1.31         946    1.67
  bson2           841.04    6.26      520.16    2.58     1386.96    3.92         946    1.67
  convert         409.50    3.05      498.88    2.47      922.93    2.61         850    1.50
##  big  ###################################################################################
  pixm           7725.87    1.19     7828.13    1.00    15612.40    1.00       23037    1.00
  json           7870.59    1.21    18458.72    2.36    26460.53    1.69       40872    1.77
  bson           6478.96    1.00    15795.28    2.02    22366.67    1.43       45625    1.98
  bson2         53894.74    8.32    26315.79    3.36    80480.00    5.15       45625    1.98
  convert       19485.44    3.01    23694.12    3.03    43739.13    2.80       40872    1.77


# codec_schema_encode.dart

dynamic      json                        35.92    1.07
dynamic      convert                     98.89    2.95
inspectable  json                        33.54    1.00
toJson       convert                    129.49    3.86
schema  dynamic            json          34.30    1.02
schema  mutable   string   json          39.57    1.18
schema  mutable   symbol   json          39.31    1.17
schema  constant  string   json          40.74    1.21
schema  constant  symbol   json          40.14    1.20
