library ormicida.benchmarks.codecSchemaEncode;

import '_schemas.dart';
import '_benchs.dart';

main() {
  _runBench();
}

void _runBench() {
  final jsonBytes = json.encode(dynamicPerson);
  final pixmBytes = pixm.encode(dynamicPerson);
  final bsonBytes = bson.encode(dynamicPerson);
  
  new BenchmarkSet('Schema decode')
    ..add(new DynamicDecodeBench('dynamic  pixm', CODEC_PIXM, pixmBytes))
    ..add(new DynamicDecodeBench('dynamic  json', CODEC_JSON, jsonBytes))
    ..add(new DynamicDecodeBench('dynamic  bson', CODEC_BSON, bsonBytes))
    ..add(new DynamicDecodeBench('dynamic  convert', CODEC_CONVERT, jsonBytes))
    ..add(new DynamicDecodeBench('dynamic  bson2', CODEC_BSON2, bsonBytes))
    
    ..add(new SchemaDecodeBench('schema  dynamic  pixm',
        pixm.decoder, pixmBytes, PERSON_SCHEMA_MUT_STRING, true))
    ..add(new SchemaDecodeBench('schema  dynamic  json',
        json.decoder, jsonBytes, PERSON_SCHEMA_MUT_STRING, true))
    ..add(new SchemaDecodeBench('schema  dynamic  bson',
        bson.decoder, bsonBytes, PERSON_SCHEMA_MUT_STRING, true))
    
    ..add(new SchemaDecodeBench('schema  mutable  string    pixm',
        pixm.decoder, pixmBytes, PERSON_SCHEMA_MUT_STRING, false))
    ..add(new SchemaDecodeBench('schema  mutable  string    json',
        json.decoder, jsonBytes, PERSON_SCHEMA_MUT_STRING, false))
    ..add(new SchemaDecodeBench('schema  mutable  string    bson',
        bson.decoder, bsonBytes, PERSON_SCHEMA_MUT_STRING, false))
    
    ..add(new SchemaDecodeBench('schema  mutable  symbol    pixm',
        pixm.decoder, pixmBytes, PERSON_SCHEMA_MUT_SYMBOL, false))
    ..add(new SchemaDecodeBench('schema  mutable  symbol    json',
        json.decoder, jsonBytes, PERSON_SCHEMA_MUT_SYMBOL, false))
    ..add(new SchemaDecodeBench('schema  mutable  symbol    bson',
        bson.decoder, bsonBytes, PERSON_SCHEMA_MUT_SYMBOL, false))
    
    ..add(new SchemaDecodeBench('schema  constant string    pixm',
        pixm.decoder, pixmBytes, PERSON_SCHEMA_CONST_STRING, false))
    ..add(new SchemaDecodeBench('schema  constant string    json',
        json.decoder, jsonBytes, PERSON_SCHEMA_CONST_STRING, false))
    ..add(new SchemaDecodeBench('schema  constant string    bson',
        bson.decoder, bsonBytes, PERSON_SCHEMA_CONST_STRING, false))
    
    ..add(new SchemaDecodeBench('schema  constant symbol    pixm',
        pixm.decoder, pixmBytes, PERSON_SCHEMA_CONST_SYMBOL, false))
    ..add(new SchemaDecodeBench('schema  constant symbol    json',
        json.decoder, jsonBytes, PERSON_SCHEMA_CONST_SYMBOL, false))
    ..add(new SchemaDecodeBench('schema  constant symbol    bson',
        bson.decoder, bsonBytes, PERSON_SCHEMA_CONST_SYMBOL, false))
    
    ..add(new SchemaDecodeBench('schema  constant fromJson  pixm',
        pixm.decoder, pixmBytes, PERSON_SCHEMA_CONST_FROM_JSON, false))
    ..add(new SchemaDecodeBench('schema  constant fromJson  json',
        json.decoder, jsonBytes, PERSON_SCHEMA_CONST_FROM_JSON, false))
    ..add(new SchemaDecodeBench('schema  constant fromJson  bson',
        bson.decoder, bsonBytes, PERSON_SCHEMA_CONST_FROM_JSON, false))
    
    ..report();
}
