library ormicida.benchmarks.codecSchemaEncode;

import '_schemas.dart';
import '_benchs.dart';

main() {
  _runBench();
}

void _runBench() {
  new BenchmarkSet('Schema encode')
    ..add(new DynamicEncodeBench('dynamic  pixm', CODEC_PIXM, dynamicPerson))
    ..add(new DynamicEncodeBench('dynamic  json', CODEC_JSON, dynamicPerson))
    ..add(new DynamicEncodeBench('dynamic  bson', CODEC_BSON, dynamicPerson))
    ..add(new DynamicEncodeBench('dynamic  bson2', CODEC_BSON2, dynamicPerson))
    ..add(new DynamicEncodeBench('dynamic  convert', CODEC_CONVERT, dynamicPerson))
    ..add(new DynamicEncodeBench('inspectable  pixm', CODEC_PIXM, mutablePerson))
    ..add(new DynamicEncodeBench('inspectable  json', CODEC_JSON, mutablePerson))
    ..add(new DynamicEncodeBench('toJson   convert', CODEC_CONVERT, mutablePerson))
    
    ..add(new SchemaEncodeBench('schema  dynamic   pixm',
        pixm.encoder, dynamicPerson, PERSON_SCHEMA_MUT_STRING))
    ..add(new SchemaEncodeBench('schema  dynamic   json',
        json.encoder, dynamicPerson, PERSON_SCHEMA_MUT_STRING))
    ..add(new SchemaEncodeBench('schema  dynamic   bson',
        bson.encoder, dynamicPerson, PERSON_SCHEMA_MUT_STRING))
    
    ..add(new SchemaEncodeBench('schema  mutable   string    pixm',
        pixm.encoder, mutablePerson, PERSON_SCHEMA_MUT_STRING))
    ..add(new SchemaEncodeBench('schema  mutable   string    json',
        json.encoder, mutablePerson, PERSON_SCHEMA_MUT_STRING))
    ..add(new SchemaEncodeBench('schema  mutable   string    bson',
        bson.encoder, mutablePerson, PERSON_SCHEMA_MUT_STRING))
    
    ..add(new SchemaEncodeBench('schema  mutable   symbol    pixm',
        pixm.encoder, mutablePerson, PERSON_SCHEMA_MUT_SYMBOL))
    ..add(new SchemaEncodeBench('schema  mutable   symbol    json',
        json.encoder, mutablePerson, PERSON_SCHEMA_MUT_SYMBOL))
    ..add(new SchemaEncodeBench('schema  mutable   symbol    bson',
        bson.encoder, mutablePerson, PERSON_SCHEMA_MUT_SYMBOL))
    
    ..add(new SchemaEncodeBench('schema  constant  string    pixm',
        pixm.encoder, constantPerson, PERSON_SCHEMA_CONST_STRING))
    ..add(new SchemaEncodeBench('schema  constant  string    json',
        json.encoder, constantPerson, PERSON_SCHEMA_CONST_STRING))
    ..add(new SchemaEncodeBench('schema  constant  string    bson',
        bson.encoder, constantPerson, PERSON_SCHEMA_CONST_STRING))
    
    ..add(new SchemaEncodeBench('schema  constant  symbol    pixm',
        pixm.encoder, constantPerson, PERSON_SCHEMA_CONST_SYMBOL))
    ..add(new SchemaEncodeBench('schema  constant  symbol    json',
        json.encoder, constantPerson, PERSON_SCHEMA_CONST_SYMBOL))
    ..add(new SchemaEncodeBench('schema  constant  symbol    bson',
        bson.encoder, constantPerson, PERSON_SCHEMA_CONST_SYMBOL))
        
    ..report();
}
