library ormicida.benchmarks.dev.json;

import 'package:benchmark_harness/benchmark_harness.dart';
import 'package:ormicida_json/ormicida_json.dart';

import '_objects.dart';

void main() {
  //_runJsonOn('little', shortObj);
  //_runJsonOn('medium', mediumObj);
  //_runJsonOn('big', longObj);

  _runDecodeOn('little', shortObj);
  _runDecodeOn('medium', mediumObj);
  _runDecodeOn('big', longObj);
}

void _runDecodeOn(String name, object) {
  final bytes = json.encode(object);
  new _DynamicDecodeBench(name, bytes).report();
  new _DynamicDecodeBench(name, bytes).report();
  new _DynamicDecodeBench(name, bytes).report();
  new _DynamicDecodeBench(name, bytes).report();
}

void _runEncodeOn(String name, object) {
  new _DynamicEncodeBench(name, object).report();
  new _DynamicEncodeBench(name, object).report();
  new _DynamicEncodeBench(name, object).report();
  new _DynamicEncodeBench(name, object).report();
}

void _runJsonOn(String name, object) {
  final bytes = json.encode(object);
  new _DynamicEncodeBench(name, object).report();
  new _DynamicDecodeBench(name, bytes).report();
  new _DynamicTotalBench(name, object).report();
}

int _counter = 0;

class _DynamicEncodeBench extends BenchmarkBase {
  final               object;
  List<int>           result;
  
  _DynamicEncodeBench(String name, this.object): super('Encode  $name');
  
  void run() {
    result = json.encode(object);
    if (result != null) _counter = 0;
  }
}

class _DynamicDecodeBench extends BenchmarkBase {
  final List<int> bytes;
  dynamic result;
  
  _DynamicDecodeBench(String name, this.bytes): super('Decode  $name');
  
  void run() {
    result = json.decode(bytes);
    if (result != null) _counter = 1;
  }
}

class _DynamicTotalBench extends BenchmarkBase {
  final               object;
  List<int>           bytes;
  var                 result;
  
  _DynamicTotalBench(String name, this.object): super('Total   $name');
  
  void run() {
    bytes = json.encode(object);
    result = json.decode(bytes);
    if (result != null) _counter = 2;
  }
}
