library ormicida.benchmarks.jsonVs;

import '_benchs.dart';

void main() {
  new EncodeBenchSet('little', shortObj).report();
  new EncodeBenchSet('medium', mediumObj).report();
  new EncodeBenchSet('big', longObj).report();
  
  new DecodeBenchSet('little', shortObj).report();
  new DecodeBenchSet('medium', mediumObj).report();
  new DecodeBenchSet('big', longObj).report();
  
  new TotalBenchSet('little', shortObj).report();
  new TotalBenchSet('medium', mediumObj).report();
  new TotalBenchSet('big', longObj).report();
}

class EncodeBenchSet extends BenchmarkSet {
  EncodeBenchSet(String name, object)
      : super('encode $name') {
    add(new DynamicEncodeBench('json', CODEC_JSON, object));
    add(new DynamicEncodeBench('convert', CODEC_CONVERT, object));
  }
}

class DecodeBenchSet extends BenchmarkSet {
  DecodeBenchSet(String name, object)
      : super('decode $name') {
    add(new DynamicDecodeBench('json', CODEC_JSON, CODEC_JSON.encode(object)));
    add(new DynamicDecodeBench('convert', CODEC_CONVERT, CODEC_CONVERT.encode(object)));
  }
}

class TotalBenchSet extends BenchmarkSet {
  TotalBenchSet(String name, object)
      : super('total $name') {
    add(new DynamicTotalBench('json', CODEC_JSON, object));
    add(new DynamicTotalBench('convert', CODEC_CONVERT, object));
  }
}

final bookObj = {
  'id': 0,
  'title': 'An Awesome Book Title',
  'releaseDate': '2010-12-25',
  'author': {'id':0,'name':'Bro Coli'},
  'price': {'amount':45.67,'currency':'€'}
};
final bookList = [
  bookObj, bookObj, bookObj, bookObj, bookObj, bookObj, bookObj, bookObj,
  bookObj, bookObj, bookObj, bookObj, bookObj, bookObj, bookObj, bookObj
];
final userObj = {
  'id': 0,
  'age': 33,
  'birthday': '1980-12-12',
  'name': 'Jonathan Wakeontime',
  'email': 'jonathan.wakeontime@someserver.com',
  'address':{'street':'Aqui 56, Ali','code':'2967-012','city':'Acolá','country':'PT'},
  'books': bookList
};
final userList = [
  userObj, userObj, userObj, userObj, userObj, userObj, userObj, userObj,
  userObj, userObj, userObj, userObj, userObj, userObj, userObj, userObj
];
final shortObj = {'success': true, 'result': 45, 'error': null};
final mediumObj =  {'success': 1, 'result': [bookObj, bookObj, bookObj, bookObj, bookObj], 'error': {'code': 'http.bind.unexpectedClose', 'argument': 'OS Error: some freaking error message'}};
final longObj =  {'success': 1, 'result': userList, 'error': {'code': 'http.bind.unexpectedClose', 'argument': 'OS Error: some freaking error message'}};
